<template>
  <v-app id="content scrollable" ref="msgContainer">
    <header :style="{ backgroundImage: `url(${actualBackground})` }">
      <div class="top">
        <div class="overlay">
          <ProductSearchBar
            :searchResult="searchResult"
            @go-to-product-list="goToProductListFiltredByName"
            @search-product-while-tapping="searchSuggestion"
          />

          <!-- <div class='div' v-bind:style='{"background-color" : (isActive? "orange" : "yellow" )}' @click="toggleClass()"></div> -->
          <button
            class="show"
            @click="showMenu()"
            v-bind:style="{transform :'rotate('+this.turn+'deg)'}"
          >|||</button>

          <section v-show="menuHasShow">
            <h1>Bilbao</h1>
            <span></span>
            <h2>AZOKA</h2>
          </section>

          <nav v-show="menuHasShow">
            <a @click="goToHome">La Principal</a>
            <a @click="goToDistrictList">Bilbao Distritos</a>
            <a @click="goToProductList">Los Productos</a>
            <a @click="goToShopList">Las Tiendas</a>
          </nav>
        </div>
      </div>
    </header>

    <content class="main">
      <router-view></router-view>
    </content>
    <footer>
      <div class="social-media-links">
        <ul>
          <li>
            <!-- twitter -->
            <a href="https://trends24.in/spain/bilbao/" target="_blank">
              <svg class="glow" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M9.5 27.1c11.2 0 17.4-9.3 17.4-17.4 0-0.3 0-0.5 0-0.8 1.2-0.9 2.2-1.9 3-3.2 -1.1 0.5-2.3 0.8-3.5 1 1.3-0.8 2.2-2 2.7-3.4 -1.2 0.7-2.5 1.2-3.9 1.5 -1.1-1.2-2.7-1.9-4.5-1.9 -3.4 0-6.1 2.7-6.1 6.1 0 0.5 0.1 0.9 0.2 1.4C9.7 10.1 5.2 7.7 2.2 4 1.7 4.9 1.4 6 1.4 7.1c0 2.1 1.1 4 2.7 5.1 -1 0-1.9-0.3-2.8-0.8 0 0 0 0.1 0 0.1 0 3 2.1 5.4 4.9 6 -0.5 0.1-1.1 0.2-1.6 0.2 -0.4 0-0.8 0-1.1-0.1 0.8 2.4 3 4.2 5.7 4.2 -2.1 1.6-4.7 2.6-7.6 2.6 -0.5 0-1 0-1.5-0.1C2.8 26.1 6 27.1 9.5 27.1"
                />
              </svg>
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M9.5 27.1c11.2 0 17.4-9.3 17.4-17.4 0-0.3 0-0.5 0-0.8 1.2-0.9 2.2-1.9 3-3.2 -1.1 0.5-2.3 0.8-3.5 1 1.3-0.8 2.2-2 2.7-3.4 -1.2 0.7-2.5 1.2-3.9 1.5 -1.1-1.2-2.7-1.9-4.5-1.9 -3.4 0-6.1 2.7-6.1 6.1 0 0.5 0.1 0.9 0.2 1.4C9.7 10.1 5.2 7.7 2.2 4 1.7 4.9 1.4 6 1.4 7.1c0 2.1 1.1 4 2.7 5.1 -1 0-1.9-0.3-2.8-0.8 0 0 0 0.1 0 0.1 0 3 2.1 5.4 4.9 6 -0.5 0.1-1.1 0.2-1.6 0.2 -0.4 0-0.8 0-1.1-0.1 0.8 2.4 3 4.2 5.7 4.2 -2.1 1.6-4.7 2.6-7.6 2.6 -0.5 0-1 0-1.5-0.1C2.8 26.1 6 27.1 9.5 27.1"
                />
              </svg>
            </a>
          </li>
          <li>
            <!-- facebook -->
            <a href="https://www.facebook.com/Bilbo.Bilbao" target="_blank">
              <svg class="glow" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M28.3 0.1H1.7c-0.9 0-1.6 0.7-1.6 1.6v26.5c0 0.9 0.7 1.6 1.6 1.6H16V18.4h-3.9v-4.5H16v-3.3c0-3.9 2.4-5.9 5.8-5.9 1.6 0 3.1 0.1 3.5 0.2v4l-2.4 0c-1.9 0-2.2 0.9-2.2 2.2v2.9h4.5l-0.6 4.5h-3.9v11.5h7.6c0.9 0 1.6-0.7 1.6-1.6V1.7C29.9 0.8 29.2 0.1 28.3 0.1z"
                />
              </svg>
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M28.3 0.1H1.7c-0.9 0-1.6 0.7-1.6 1.6v26.5c0 0.9 0.7 1.6 1.6 1.6H16V18.4h-3.9v-4.5H16v-3.3c0-3.9 2.4-5.9 5.8-5.9 1.6 0 3.1 0.1 3.5 0.2v4l-2.4 0c-1.9 0-2.2 0.9-2.2 2.2v2.9h4.5l-0.6 4.5h-3.9v11.5h7.6c0.9 0 1.6-0.7 1.6-1.6V1.7C29.9 0.8 29.2 0.1 28.3 0.1z"
                />
              </svg>
            </a>
          </li>
          <li>
            <!-- youtube -->
            <a href="https://www.youtube.com/watch?v=PobXcrUzJBc" target="_blank">
              <svg class="glow" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M29.7 9c0 0-0.3-2.1-1.2-3 -1.1-1.2-2.4-1.2-3-1.3C21.3 4.5 15 4.5 15 4.5h0c0 0-6.3 0-10.5 0.3C3.9 4.8 2.6 4.8 1.5 6 0.6 6.9 0.3 9 0.3 9S0 11.4 0 13.9v2.3C0 18.6 0.3 21 0.3 21s0.3 2.1 1.2 3c1.1 1.2 2.6 1.2 3.3 1.3C7.2 25.5 15 25.6 15 25.6s6.3 0 10.5-0.3c0.6-0.1 1.9-0.1 3-1.3 0.9-0.9 1.2-3 1.2-3s0.3-2.4 0.3-4.9v-2.3C30 11.4 29.7 9 29.7 9zM11.9 18.9l0-8.4 8.1 4.2L11.9 18.9z"
                />
              </svg>
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M29.7 9c0 0-0.3-2.1-1.2-3 -1.1-1.2-2.4-1.2-3-1.3C21.3 4.5 15 4.5 15 4.5h0c0 0-6.3 0-10.5 0.3C3.9 4.8 2.6 4.8 1.5 6 0.6 6.9 0.3 9 0.3 9S0 11.4 0 13.9v2.3C0 18.6 0.3 21 0.3 21s0.3 2.1 1.2 3c1.1 1.2 2.6 1.2 3.3 1.3C7.2 25.5 15 25.6 15 25.6s6.3 0 10.5-0.3c0.6-0.1 1.9-0.1 3-1.3 0.9-0.9 1.2-3 1.2-3s0.3-2.4 0.3-4.9v-2.3C30 11.4 29.7 9 29.7 9zM11.9 18.9l0-8.4 8.1 4.2L11.9 18.9z"
                />
              </svg>
            </a>
          </li>
          <li>
            <!-- instagram -->
            <a href="https://www.instagram.com/" target="_blank">
              <svg class="glow" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M15 2.8c4 0 4.4 0 6 0.1 1.4 0.1 2.2 0.3 2.8 0.5 0.7 0.3 1.2 0.6 1.7 1.1 0.5 0.5 0.8 1 1.1 1.7C26.8 6.8 27 7.6 27.1 9c0.1 1.6 0.1 2 0.1 6s0 4.4-0.1 6c-0.1 1.4-0.3 2.2-0.5 2.8 -0.3 0.7-0.6 1.2-1.1 1.7 -0.5 0.5-1 0.8-1.7 1.1 -0.5 0.2-1.3 0.4-2.8 0.5 -1.6 0.1-2 0.1-6 0.1s-4.4 0-6-0.1c-1.4-0.1-2.2-0.3-2.8-0.5 -0.7-0.3-1.2-0.6-1.7-1.1 -0.5-0.5-0.8-1-1.1-1.7C3.2 23.2 3 22.4 2.9 21c-0.1-1.6-0.1-2-0.1-6s0-4.4 0.1-6C3 7.6 3.2 6.8 3.4 6.2 3.7 5.5 4 5.1 4.5 4.5c0.5-0.5 1-0.8 1.7-1.1C6.8 3.2 7.6 3 9 2.9 10.6 2.8 11 2.8 15 2.8M15 0.2c-4 0-4.5 0-6.1 0.1C7.3 0.3 6.2 0.6 5.3 0.9c-1 0.4-1.8 0.9-2.6 1.7C1.8 3.5 1.3 4.3 0.9 5.3c-0.4 0.9-0.6 2-0.7 3.6C0.2 10.5 0.1 11 0.1 15c0 4 0 4.5 0.1 6.1 0.1 1.6 0.3 2.7 0.7 3.6 0.4 1 0.9 1.8 1.7 2.6 0.8 0.8 1.7 1.3 2.6 1.7 0.9 0.4 2 0.6 3.6 0.7 1.6 0.1 2.1 0.1 6.1 0.1s4.5 0 6.1-0.1c1.6-0.1 2.7-0.3 3.6-0.7 1-0.4 1.8-0.9 2.6-1.7 0.8-0.8 1.3-1.7 1.7-2.6 0.4-0.9 0.6-2 0.7-3.6 0.1-1.6 0.1-2.1 0.1-6.1s0-4.5-0.1-6.1c-0.1-1.6-0.3-2.7-0.7-3.6 -0.4-1-0.9-1.8-1.7-2.6 -0.8-0.8-1.7-1.3-2.6-1.7 -0.9-0.4-2-0.6-3.6-0.7C19.5 0.2 19 0.2 15 0.2L15 0.2z"
                />
                <path
                  class="st0"
                  d="M15 7.4c-4.2 0-7.6 3.4-7.6 7.6s3.4 7.6 7.6 7.6 7.6-3.4 7.6-7.6S19.2 7.4 15 7.4zM15 20c-2.7 0-5-2.2-5-5s2.2-5 5-5c2.7 0 5 2.2 5 5S17.7 20 15 20z"
                />
                <circle class="st0" cx="22.9" cy="7.1" r="1.8" />
              </svg>
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 30 30">
                <path
                  class="st0"
                  d="M15 2.8c4 0 4.4 0 6 0.1 1.4 0.1 2.2 0.3 2.8 0.5 0.7 0.3 1.2 0.6 1.7 1.1 0.5 0.5 0.8 1 1.1 1.7C26.8 6.8 27 7.6 27.1 9c0.1 1.6 0.1 2 0.1 6s0 4.4-0.1 6c-0.1 1.4-0.3 2.2-0.5 2.8 -0.3 0.7-0.6 1.2-1.1 1.7 -0.5 0.5-1 0.8-1.7 1.1 -0.5 0.2-1.3 0.4-2.8 0.5 -1.6 0.1-2 0.1-6 0.1s-4.4 0-6-0.1c-1.4-0.1-2.2-0.3-2.8-0.5 -0.7-0.3-1.2-0.6-1.7-1.1 -0.5-0.5-0.8-1-1.1-1.7C3.2 23.2 3 22.4 2.9 21c-0.1-1.6-0.1-2-0.1-6s0-4.4 0.1-6C3 7.6 3.2 6.8 3.4 6.2 3.7 5.5 4 5.1 4.5 4.5c0.5-0.5 1-0.8 1.7-1.1C6.8 3.2 7.6 3 9 2.9 10.6 2.8 11 2.8 15 2.8M15 0.2c-4 0-4.5 0-6.1 0.1C7.3 0.3 6.2 0.6 5.3 0.9c-1 0.4-1.8 0.9-2.6 1.7C1.8 3.5 1.3 4.3 0.9 5.3c-0.4 0.9-0.6 2-0.7 3.6C0.2 10.5 0.1 11 0.1 15c0 4 0 4.5 0.1 6.1 0.1 1.6 0.3 2.7 0.7 3.6 0.4 1 0.9 1.8 1.7 2.6 0.8 0.8 1.7 1.3 2.6 1.7 0.9 0.4 2 0.6 3.6 0.7 1.6 0.1 2.1 0.1 6.1 0.1s4.5 0 6.1-0.1c1.6-0.1 2.7-0.3 3.6-0.7 1-0.4 1.8-0.9 2.6-1.7 0.8-0.8 1.3-1.7 1.7-2.6 0.4-0.9 0.6-2 0.7-3.6 0.1-1.6 0.1-2.1 0.1-6.1s0-4.5-0.1-6.1c-0.1-1.6-0.3-2.7-0.7-3.6 -0.4-1-0.9-1.8-1.7-2.6 -0.8-0.8-1.7-1.3-2.6-1.7 -0.9-0.4-2-0.6-3.6-0.7C19.5 0.2 19 0.2 15 0.2L15 0.2z"
                />
                <path
                  class="st0"
                  d="M15 7.4c-4.2 0-7.6 3.4-7.6 7.6s3.4 7.6 7.6 7.6 7.6-3.4 7.6-7.6S19.2 7.4 15 7.4zM15 20c-2.7 0-5-2.2-5-5s2.2-5 5-5c2.7 0 5 2.2 5 5S17.7 20 15 20z"
                />
                <circle class="st0" cx="22.9" cy="7.1" r="1.8" />
              </svg>
            </a>
          </li>
        </ul>
      </div>
    </footer>
  </v-app>
</template>

<script>
import ProductSearchBar from "@/components/Header/ProductSearchBar.vue";

import API from "@/API.js";
export default {
  name: "App",
  components: {
    // Header
    ProductSearchBar
  },
  data() {
    return {
      turn: 90,
      menuHasShow: true,
      count: 5,
      searchResult: [],
      backgroundImage: "",
      actualBackground: "",
      time: "",
      timestamp: "",
      hour: "",
      test: Number(this.hour)
    };
  },
  async mounted() {
    this.loadHome();
    this.backgroundImage = await API.getBackgroundImage();
    setInterval(this.calculateTime, 1000);

    this.verifyScreenWidth();

    if (8 < this.hour < 10) {
      this.actualBackground = this.backgroundImage[0].background_img;
    } else {
      this.actualBackground = this.backgroundImage[1].background_img;
    }
  },
  watch: {
    count: function() {
      this.$nextTick(function() {
        var container = this.$refs.msgContainer;
        container.scrollTop = container.scrollHeight + 120;
      });
    }
  },

  methods: {
    verifyScreenWidth() {
      var mq = window.matchMedia("(max-width: 500px)");
      if (mq.matches) {
        // window width is at less than 570px
        this.menuHasShow = false;
      } else {
        // window width is greater than 570px
        this.menuHasShow = true;
      }
    },

    showMenu() {
      this.menuHasShow = !this.menuHasShow;
      if (this.menuHasShow === true) {
        this.turn = 0;
      } else {
        this.turn = 90;
      }
    },
    calculateTime() {
      const today = new Date();
      const date =
        today.getFullYear() +
        "-" +
        (today.getMonth() + 1) +
        "-" +
        today.getDate();
      this.hour = today.getHours();
      this.time =
        today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
      const dateTime = date + " " + this.time;
      this.timestamp = dateTime;
    },
    loadHome() {
      this.$router.push("/home");
    },
    async searchSuggestion(searchedWord) {
      this.searchResult = await API.loadProductsListFiltredBySearchedName(
        searchedWord
      );
    },
    goToProductListFiltredByName(searchedProductName) {
      this.$router.push(
        "/product-List/searchedProductsByName/" + searchedProductName
      );
    },
    goToHome() {
      this.$router.push("/home");
      this.verifyScreenWidth();
    },
    goToProductList() {
      this.$router.push("/Product-List");
      this.verifyScreenWidth();
    },
    goToShopList() {
      this.$router.push("/Shop-List");
      this.verifyScreenWidth();
    },
    goToDistrictList() {
      this.$router.push("/Bilbao-District");
      this.verifyScreenWidth();
    }
  }
};
</script>

<style scoped>
* {
  padding: 0;
  margin: 0;
  box-sizing: border-box;
}
.top {
  padding: 0;
  margin: 0;
  box-sizing: border-box;
}

#scrollable {
  overflow: hidden;
  overflow-y: scroll;
  height: calc(100vh - 20px);
}

#app {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin: 0;
}
nav {
  display: flex;
  flex-direction: row;
  justify-content: space-evenly;
}
section {
  display: flex;
  flex-direction: row;
  justify-content: center;
  margin-bottom: 15%;
  margin-top: 5%;
}
.main {
  padding: 4.5rem;
  margin-top: 6.5rem;

  height: auto;
}

body {
  height: auto;
}
header {
  /* background: url("https://www.dosde.com/media/catalog/product/cache/1/image/9df78eab33525d08d6e5fb8d27136e95/p/u/puente-san-anton-bilbao-dosde-publishing_978-84-9103-120-8_35-016-00_C01.jpg"); */

  text-align: center;
  width: 100%;
  height: auto;
  background-size: cover;
  background-attachment: fixed;
  position: relative;
  overflow: hidden;
  border-radius: 0 0 85% 85% / 30%;
  margin-bottom: -8%;
}
header .overlay {
  width: 100%;
  height: 100%;
  padding: 20px;
  color: #fff;
  text-shadow: 1px 1px 1px #333;
  background-image: linear-gradient(135deg, #9f05ff69 10%, #fd5e086b 100%);
}

h1 {
  font-size: 80px;
  margin-bottom: -47px;
  font-family: "oxygen", regular;
  text-transform: uppercase;
}
h2 {
  font-size: 80px;
  margin-bottom: -47px;
  font-family: "oxygen", bold;
  text-transform: uppercase;
}

h3,
nav a {
  border: none;
  padding: 10px 20px;
  font-family: "serifa Lora", regular;

  color: white;
  font-size: 25px;
  margin-bottom: 50px;
}
button {
  border: none;
  outline: none;
  padding: 10px 20px;
  border-radius: 50px;
  color: #333;
  background: #fff;
  margin-bottom: 50px;
  box-shadow: 0 3px 20px 0 #0000003b;
}
button:hover {
  cursor: pointer;
}

@import url(
  https://fonts.googleapis.com/css?family=Source+Sans+Pro:400,
  200,
  300,
  600,
  700,
  900
);

footer {
  bottom: 0;
  left: 0;
  position: absolute;
  right: 0;
}
footer div.social-media-links {
  background: #323b40;
  overflow: hidden;
  padding-bottom: 4px;
  text-align: center;
}
footer div.social-media-links ul {
  display: flex;
  justify-content: space-around;
  margin: 0;
  padding: 0;
}
footer div.social-media-links li {
  display: inline;
  margin: 0;
  padding: 0;
}
footer div.social-media-links a {
  border-bottom: 0px solid rgba(0, 0, 0, 0.95);
  border-radius: 4px;
  box-shadow: inset 0 -3px 0 0 rgba(0, 0, 0, 0), 0 6px 8px rgba(0, 0, 0, 0),
    0 24px 24px rgba(0, 0, 0, 0), 0 36px 36px rgba(0, 0, 0, 0),
    0 64px 64px rgba(0, 0, 0, 0), 0 64px 128px rgba(0, 0, 0, 0),
    0 120px 0 rgba(0, 0, 0, 0), 0 86px 8px 6px rgba(0, 0, 0, 0);
  display: inline-block;
  height: 30px;
  padding: 20px;
  position: relative;
  transition: 0.2s ease-in;
  width: 30px;
}
footer div.social-media-links a svg {
  left: 20px;
  position: absolute;
  top: 20px;
  height: 30px;
  width: 30px;
}
footer div.social-media-links a svg.glow path,
footer div.social-media-links a svg.glow circle {
  fill: rgba(0, 0, 0, 0);
}
footer div.social-media-links a svg path,
footer div.social-media-links a svg circle {
  fill: #0096a1;
  transition: 0.2s ease-in;
}
footer div.social-media-links a:hover {
  transform: translateY(-4px);
  box-shadow: inset 0 -3px 0 0 rgba(0, 0, 0, 0.1), 0 6px 8px rgba(0, 0, 0, 0.05),
    0 24px 24px rgba(0, 0, 0, 0.05), 0 36px 36px rgba(0, 0, 0, 0.05),
    0 64px 64px rgba(0, 0, 0, 0.15), 0 64px 128px rgba(0, 0, 0, 0.15),
    0 86px 8px 6px rgba(14, 186, 199, 0.25),
    0 83px 4px 0px rgba(14, 186, 199, 0.95);
}
footer div.social-media-links a:hover svg.glow {
  filter: url('data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg"><f…ter id="filter"><feGaussianBlur stdDeviation="10" /></filter></svg>#filter');
  filter: blur(2px);
}
footer div.social-media-links a:hover svg.glow path,
footer div.social-media-links a:hover svg.glow circle {
  fill: rgba(14, 186, 199, 0.6);
}
footer div.social-media-links a:hover svg path,
footer div.social-media-links a:hover svg circle {
  fill: #0ebac7;
}
.show {
  display: none;
}

@media only screen and (max-width: 500px) {
  /* For mobile phones: */
  .show {
    display: inline;
  }
  nav {
    flex-direction: column;
    margin-top: 10%;
  }
  .main {
    margin-top: 2rem;
  }
  p {
    display: none;
  }
  section {
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin-bottom: 15%;
    margin-top: 5%;
  }
}
</style>
